#!/usr/bin/perl
#
# kokusaihoken-fpw - FreePWING script for KOKUSAIHOKEN
#
# Copyright (C) 2013, Susumu Tanimura
# This program is distributed in the hope that it will be useful, but
# without any warranty. See the GNU General Public License for the details.

use FreePWING::FPWUtils::FPWParser;

## ʥ󥹥󥹤ȺȥեΥץ
initialize_fpwparser('text' => \$fpwtext,
										 'heading' => \$fpwheading,
										 'word2' => \$fpwword2);

while(<>){
		if ($_ =~ /<heading>(.*)<\/heading>/) {
				$frag = 1;
				push(@Head, $1);
		}else{
				if ($frag == 1){
						push(@Text, $text);
						$frag = 0;
						$text = $_;
				}else{ 
						$text .= $_;
				}
		}
}
push(@Text, $text);
shift(@Text);

for my $i (0 .. $#Head) {
		## ʸȸФ򿷤ȥڤؤ롣
		$fpwtext->new_entry() || die $fpwtext->error_message() . "\n";
		$fpwheading->new_entry() || die $fpwheading->error_message() . "\n";
		## Ф񤭹ࡣ
		$fpwheading->add_text(@Head[$i]) || die $fpwheading->error_message() . "\n";
		## ʸ񤭹ࡣ
		if (!$fpwtext->add_keyword_start() 
				|| !$fpwtext->add_text(@Head[$i]) 
				|| !$fpwtext->add_keyword_end() 
				|| !$fpwtext->add_newline()
				|| !$fpwtext->add_text($Text[$i])
				|| !$fpwtext->add_newline()
				|| !$fpwtext->add_newline()) {
				die $fpwtext->error_message() . "\n";
		}
		## Ͽ
		$heading_position = $fpwheading->entry_position();
		$text_position = $fpwtext->entry_position();
		if (!$fpwword2->add_entry(@Head[$i], $heading_position, $text_position)) {
				die $fpwword2->error_message() . "\n";
		}
}

## 񤭹ѤκȥեĤ롣
finalize_fpwparser('text' => \$fpwtext,
									 'heading' => \$fpwheading,
									 'word2' => \$fpwword2);

